// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

assertEquals("1", V8ToName(1));
assertEquals("1", V8ToName(1));

assertEquals("0.5", V8ToName(.5));
assertEquals("0.5", V8ToName(.5));

assertEquals("null", V8ToName(null));
assertEquals("null", V8ToName(null));

assertEquals("true", V8ToName(true));
assertEquals("true", V8ToName(true));

assertEquals("false", V8ToName(false));
assertEquals("false", V8ToName(false));

assertEquals("undefined", V8ToName(undefined));
assertEquals("undefined", V8ToName(undefined));

assertEquals("random text", V8ToName("random text"));
assertEquals("random text", V8ToName("random text"));

assertEquals(Symbol.toPrimitive, V8ToName(Symbol.toPrimitive));
assertEquals(Symbol.toPrimitive, V8ToName(Symbol.toPrimitive));

var a = { toString: function() { return "xyz" }};
assertEquals("xyz", V8ToName(a));
assertEquals("xyz", V8ToName(a));

var b = { valueOf: function() { return 42 }};
assertEquals("[object Object]", V8ToName(b));
assertEquals("[object Object]", V8ToName(b));

var c = {
  toString: function() { return "x"},
  valueOf: function() { return 123 }
};
assertEquals("x", V8ToName(c));
assertEquals("x", V8ToName(c));

var d = {
  [Symbol.toPrimitive]: function(hint) { return hint }
};
assertEquals("string", V8ToName(d));
assertEquals("string", V8ToName(d));

var e = new Date(0);
assertEquals(e.toString(), V8ToName(e));
assertEquals(e.toString(), V8ToName(e));
