// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

assertEquals(1, V8ToNumber(1));
assertEquals(1, V8ToNumber(1));

assertEquals(.5, V8ToNumber(.5));
assertEquals(.5, V8ToNumber(.5));

assertEquals(0, V8ToNumber(null));
assertEquals(0, V8ToNumber(null));

assertEquals(1, V8ToNumber(true));
assertEquals(1, V8ToNumber(true));

assertEquals(0, V8ToNumber(false));
assertEquals(0, V8ToNumber(false));

assertEquals(NaN, V8ToNumber(undefined));
assertEquals(NaN, V8ToNumber(undefined));

assertEquals(-1, V8ToNumber("-1"));
assertEquals(-1, V8ToNumber("-1"));
assertEquals(123, V8ToNumber("123"));
assertEquals(123, V8ToNumber("123"));
assertEquals(NaN, V8ToNumber("random text"));
assertEquals(NaN, V8ToNumber("random text"));

assertThrows(function() { V8ToNumber(Symbol.toPrimitive) }, TypeError);
assertThrows(function() { V8ToNumber(Symbol.toPrimitive) }, TypeError);

var a = { toString: function() { return 54321 }};
assertEquals(54321, V8ToNumber(a));
assertEquals(54321, V8ToNumber(a));

var b = { valueOf: function() { return 42 }};
assertEquals(42, V8ToNumber(b));
assertEquals(42, V8ToNumber(b));

var c = {
  toString: function() { return "x"},
  valueOf: function() { return 123 }
};
assertEquals(123, V8ToNumber(c));
assertEquals(123, V8ToNumber(c));

var d = {
  [Symbol.toPrimitive]: function(hint) {
    assertEquals("number", hint);
    return 987654321;
  }
};
assertEquals(987654321, V8ToNumber(d));
assertEquals(987654321, V8ToNumber(d));

var e = new Date(0);
assertEquals(0, V8ToNumber(e));
assertEquals(0, V8ToNumber(e));
